MODULE Dim
  SAVE
  integer(kind=4)::nx=8
  integer(kind=4)::ny=4
  integer(kind=4)::nxm=8
  integer(kind=4)::nym=4
  integer(kind=4)::nxpt=1
  integer(kind=4)::nhsp=1
  integer(kind=4)::nzspt
  integer(kind=4)::nzspmx=10
  integer(kind=4)::nisp=1
  integer(kind=4)::nusp
  integer(kind=4)::nfsp
  integer(kind=4)::ngsp=1
  integer(kind=4)::nhgsp=1
  integer(kind=4)::imx=50
  integer(kind=4)::imy=40
  integer(kind=4)::lnst=43
  integer(kind=4)::nzsp(1:6-1)
  data nzsp/5*0/
END MODULE Dim
MODULE RZ_grid_info
  SAVE
  real(kind=8),pointer::rm(:,:,:)
  real(kind=8),pointer::zm(:,:,:)
  real(kind=8),pointer::rmt(:,:,:)
  real(kind=8),pointer::zmt(:,:,:)
  real(kind=8),pointer::rv(:,:)
  real(kind=8),pointer::zv(:,:)
  real(kind=8),pointer::psi(:,:,:)
  real(kind=8),pointer::br(:,:,:)
  real(kind=8),pointer::bz(:,:,:)
  real(kind=8),pointer::bpol(:,:,:)
  real(kind=8),pointer::bphi(:,:,:)
  real(kind=8),pointer::b(:,:,:)
END MODULE RZ_grid_info
MODULE RZ_grid_global
  SAVE
  real(kind=8),pointer::rmg(:,:,:)
  real(kind=8),pointer::zmg(:,:,:)
  real(kind=8),pointer::psig(:,:,:)
  real(kind=8),pointer::brg(:,:,:)
  real(kind=8),pointer::bzg(:,:,:)
  real(kind=8),pointer::bpolg(:,:,:)
  real(kind=8),pointer::bphig(:,:,:)
  real(kind=8),pointer::bg(:,:,:)
END MODULE RZ_grid_global
MODULE Share
  SAVE
  integer(kind=4)::nxomit=0
  integer(kind=4)::nxxpt
  integer(kind=4)::nyomitmx=0
  integer(kind=4)::igrid=1
  integer(kind=4)::nxc=4
  real(kind=8)::simagxs
  real(kind=8)::sibdrys
  integer(kind=4)::ismpsym=0
  integer(kind=4)::islimon=0
  integer(kind=4)::ix_lim
  integer(kind=4)::iy_lims=9999
  real(kind=8)::theta_split=1.570796326794896
  integer(kind=4)::isnonog=0
  integer(kind=4)::ismmon=0
  integer(kind=4)::isoldgrid=0
  integer(kind=4)::isgrdsym=0
  real(kind=8)::cutlo=1.e-300
  real(kind=8)::epslon=1e-6
  integer(kind=4)::spheromak=0
  integer(kind=4)::isfrc=0
  integer(kind=4)::ishalfm=0
  integer(kind=4)::isbphicon=0
  integer(kind=4)::nhdf=1
  integer(kind=4)::nzdf=1
  integer(kind=4)::istabon=7
  integer(kind=4)::nycore(30)
  data nycore/30*0/
  integer(kind=4)::nysol(30)
  data nysol/30*2/
  integer(kind=4)::nyout(30)
  data nyout/30*0/
  integer(kind=4)::nxleg(30,2)
  data nxleg/0, 59*2/
  integer(kind=4)::nxcore(30,2)
  data nxcore/0, 59*4/
  character(len=8)::geometry
  data geometry/"snull"/
  character(len=256)::hdfilename(1:12)
  data hdfilename/12*'b2frates'/
  character(len=256)::mcfilename(1:12)
  data mcfilename/12*'b2frates'/
END MODULE Share
MODULE Xpoint_indices
  SAVE
  integer(kind=4)::iysptrx
  integer(kind=4),pointer::ixlb(:)
  integer(kind=4),pointer::ixpt1(:)
  integer(kind=4),pointer::ixmdp(:)
  integer(kind=4),pointer::ixpt2(:)
  integer(kind=4),pointer::ixrb(:)
  integer(kind=4),pointer::iysptrx1(:)
  integer(kind=4),pointer::iysptrx2(:)
END MODULE Xpoint_indices
MODULE Comgeo
  SAVE
  real(kind=8)::psishift=0.
  real(kind=8)::sygytotc
  real(kind=8)::ghxpt
  real(kind=8)::gvxpt
  real(kind=8)::sxyxpt
  real(kind=8)::ghxpt_lower
  real(kind=8)::gvxpt_lower
  real(kind=8)::sxyxpt_lower
  real(kind=8)::ghxpt_upper
  real(kind=8)::gvxpt_upper
  real(kind=8)::sxyxpt_upper
  real(kind=8)::linelen
  real(kind=8),pointer::vol(:,:)
  real(kind=8),pointer::gx(:,:)
  real(kind=8),pointer::gy(:,:)
  real(kind=8),pointer::dx(:,:)
  real(kind=8),pointer::dy(:,:)
  real(kind=8),pointer::gxf(:,:)
  real(kind=8),pointer::gxfn(:,:)
  real(kind=8),pointer::gyf(:,:)
  real(kind=8),pointer::gxc(:,:)
  real(kind=8),pointer::gyc(:,:)
  real(kind=8),pointer::xnrm(:,:)
  real(kind=8),pointer::xvnrm(:,:)
  real(kind=8),pointer::ynrm(:,:)
  real(kind=8),pointer::yvnrm(:,:)
  real(kind=8),pointer::sx(:,:)
  real(kind=8),pointer::sy(:,:)
  real(kind=8),pointer::rr(:,:)
  real(kind=8),pointer::xcs(:)
  real(kind=8),pointer::xfs(:)
  real(kind=8),pointer::xcwi(:)
  real(kind=8),pointer::xfwi(:)
  real(kind=8),pointer::xfpf(:)
  real(kind=8),pointer::xcpf(:)
  real(kind=8),pointer::xcwo(:)
  real(kind=8),pointer::xfwo(:)
  real(kind=8),pointer::yyc(:)
  real(kind=8),pointer::yyf(:)
  real(kind=8),pointer::yylb(:,:)
  real(kind=8),pointer::yyrb(:,:)
  real(kind=8),pointer::xcv(:)
  real(kind=8),pointer::xfv(:)
  real(kind=8),pointer::psinormc(:)
  real(kind=8),pointer::psinormf(:)
  real(kind=8),pointer::rrv(:,:)
  real(kind=8),pointer::volv(:,:)
  real(kind=8),pointer::hxv(:,:)
  real(kind=8),pointer::syv(:,:)
  integer(kind=4),pointer::isxptx(:,:)
  integer(kind=4),pointer::isxpty(:,:)
  real(kind=8),pointer::lcon(:,:)
  real(kind=8),pointer::lconi(:,:)
  real(kind=8),pointer::lcone(:,:)
END MODULE Comgeo
MODULE Noggeo
  SAVE
  real(kind=8),pointer::vtag(:,:)
  real(kind=8),pointer::angfx(:,:)
  real(kind=8),pointer::fxm(:,:,:)
  real(kind=8),pointer::fx0(:,:,:)
  real(kind=8),pointer::fxp(:,:,:)
  real(kind=8),pointer::fym(:,:,:)
  real(kind=8),pointer::fy0(:,:,:)
  real(kind=8),pointer::fyp(:,:,:)
  real(kind=8),pointer::fxmy(:,:,:)
  real(kind=8),pointer::fxpy(:,:,:)
  real(kind=8),pointer::fymx(:,:,:)
  real(kind=8),pointer::fypx(:,:,:)
  real(kind=8),pointer::fxmv(:,:,:)
  real(kind=8),pointer::fx0v(:,:,:)
  real(kind=8),pointer::fxpv(:,:,:)
  real(kind=8),pointer::fymv(:,:,:)
  real(kind=8),pointer::fy0v(:,:,:)
  real(kind=8),pointer::fypv(:,:,:)
  real(kind=8),pointer::fxmyv(:,:,:)
  real(kind=8),pointer::fxpyv(:,:,:)
  real(kind=8),pointer::fymxv(:,:,:)
  real(kind=8),pointer::fypxv(:,:,:)
END MODULE Noggeo
MODULE Timing
  SAVE
  integer(kind=4)::istimingon=1
  integer(kind=4)::iprinttim=0
  real(kind=8)::ttotfe=0.
  real(kind=8)::ttimpfe=0.
  real(kind=8)::ttotjf=0.
  real(kind=8)::ttimpjf=0.
  real(kind=8)::ttmatfac=0.
  real(kind=8)::ttmatsol=0.
  real(kind=8)::ttjstor=0.
  real(kind=8)::ttjrnorm=0.
  real(kind=8)::ttjreorder=0.
  real(kind=8)::ttimpc=0.
  real(kind=8)::tstart=0.
  real(kind=8)::tend=0.
END MODULE Timing
MODULE Linkbbb
  SAVE
  integer(kind=4)::nxbbb
  integer(kind=4)::nybbb
  integer(kind=4)::nycorebbb
  integer(kind=4)::nysolbbb
  integer(kind=4)::nxleg1bbb
  integer(kind=4)::nxcore1bbb
  integer(kind=4)::nxleg2bbb
  integer(kind=4)::nxcore2bbb
  character(len=8)::geometrybbb
  real(kind=8),pointer::nibbb(:,:)
  real(kind=8),pointer::tibbb(:,:)
  real(kind=8),pointer::nebbb(:,:)
  real(kind=8),pointer::tebbb(:,:)
  real(kind=8),pointer::vflowxbbb(:,:)
  real(kind=8),pointer::vflowybbb(:,:)
  real(kind=8),pointer::vflowzbbb(:,:)
  real(kind=8),pointer::fnixbbb(:,:)
  real(kind=8),pointer::fngysibbb(:)
  real(kind=8),pointer::fngysobbb(:)
END MODULE Linkbbb
MODULE Timespl
  SAVE
  real(kind=8)::totb2val=0.
  real(kind=8)::totintrv=0.
END MODULE Timespl
MODULE Limiter
  SAVE
  integer(kind=4)::nlimu
  integer(kind=4)::nptnma
  real(kind=8)::rptnma
  real(kind=8)::zptnma
  real(kind=8)::dslims=.0001
  integer(kind=4)::nsplit1
  integer(kind=4)::nsplit2
  real(kind=8),pointer::rlimu(:)
  real(kind=8),pointer::zlimu(:)
  real(kind=8),pointer::rsplit1(:)
  real(kind=8),pointer::zsplit1(:)
  real(kind=8),pointer::rsplit2(:)
  real(kind=8),pointer::zsplit2(:)
END MODULE Limiter
MODULE Multicharge
  SAVE
  integer(kind=4)::ntev=101
  integer(kind=4)::nz=2
  integer(kind=4)::rtnt
  integer(kind=4)::rtnn
  integer(kind=4)::rtns
  integer(kind=4)::rtnsd
  real(kind=8)::iscxfit=1.
  integer(kind=4)::isrtndep=0
  real(kind=8),pointer::tevb(:)
  real(kind=8),pointer::rsi(:,:)
  real(kind=8),pointer::rre(:,:)
  real(kind=8),pointer::rpwr(:,:)
  real(kind=8),pointer::rrcx(:,:)
  character(len=120)::labelrt(1:12)
  real(kind=8),pointer::rtza(:)
  real(kind=8),pointer::rtzn(:)
  real(kind=8),pointer::rtza2(:)
  real(kind=8),pointer::rtt(:)
  real(kind=8),pointer::rtn(:)
  real(kind=8),pointer::rtlt(:)
  real(kind=8),pointer::rtln(:)
  real(kind=8),pointer::rtlsa(:,:,:)
  real(kind=8),pointer::rtlra(:,:,:)
  real(kind=8),pointer::rtlqa(:,:,:)
  real(kind=8),pointer::rtlcx(:,:,:)
END MODULE Multicharge
MODULE Fitdata
  SAVE
  integer(kind=4)::ncoefne_tanh=1
  integer(kind=4)::ncoefte_tanh=1
  integer(kind=4)::numt_bs=1
  integer(kind=4)::numc_bs=1
  integer(kind=4)::numk_bs=1
  real(kind=8),pointer::fcoefne_tanh(:)
  real(kind=8),pointer::fcoefte_tanh(:)
  character(len=8)::fit_paramne_tanh
  character(len=8)::fit_paramte_tanh
  real(kind=8),pointer::fit_t_bs(:)
  real(kind=8),pointer::fcoef_bs(:)
  real(kind=8),pointer::nefit(:)
  real(kind=8),pointer::tefit(:)
  real(kind=8),pointer::tifit(:)
END MODULE Fitdata
MODULE PETSc_Snes_Param
  SAVE
  integer(kind=4)::psp_nsnes=0
  integer(kind=4)::psp_Jmat=0
  integer(kind=4)::psp_JmatType=0
  integer(kind=4)::psp_fdcoloring=0
  integer(kind=4)::psp_usecolor=0
  integer(kind=4)::psp_F=0
  integer(kind=4)::psp_Floc=0
  integer(kind=4)::psp_X=0
  integer(kind=4)::psp_Xtmp=0
  integer(kind=4)::psp_Xloc=0
  integer(kind=4)::psp_SFVEC=0
  integer(kind=4)::psp_SUVEC=0
  integer(kind=4)::psp_ISUVEC=0
  integer(kind=4)::psp_isf=1
  integer(kind=4)::psp_isu=1
  integer(kind=4)::psp_ijnr=0
  real(kind=8)::snesatol=1.e-10
  real(kind=8)::snesrtol=0.0
  real(kind=8)::snesstol=0.0
  integer(kind=4)::psp_snesits=30
  integer(kind=4)::snesfcts=10000
  integer(kind=4)::snesdebug=0
  integer(kind=4)::ksprestart=25
  integer(kind=4)::kspmaxits=100000
  integer(kind=4)::kspcurrits=0
  real(kind=8)::ksprtol=1.e-5
  real(kind=8)::kspatol=1.e-50
  real(kind=8)::kspdtol=1.e5
  character(len=8)::psp_pcname(20)
  real(kind=8),pointer::psp_fnrm(:)
  real(kind=8),pointer::psp_time(:)
  integer(kind=4),pointer::psp_kspits(:)
  real(kind=8),pointer::nksolfnrm(:)
  real(kind=8),pointer::nksoltime(:)
  integer(kind=4),pointer::nksollinits(:)
  integer(kind=4),pointer::nksolfeval(:)
END MODULE PETSc_Snes_Param
